## hardening-wrapper 2.6

=== debian/changelog ===
hardening-wrapper (2.6) unstable; urgency=medium

  * Acknowledge NMU, thanks Aurelien Jarno!
  * debian/rules: add clarifying comment about dpkg-buildflags.
  * hardening.make, debian/README.Debian:
    - switch to -fstack-protector-strong, thanks to Romain Francoise
      (Closes: 762662).
    - enable stack protector on mips*, arm64.
  * hardened-cc: use -fstack-protector-strong when old GCC not found.
  * tests/
    - Makefile: add -fstack-protector-strong to logs
    - Makefile.common, ssp-buffer-type-protect.c: check for -strong behavior

 -- Kees Cook <kees@debian.org>  Wed, 24 Sep 2014 07:51:25 -0700

=== debian/control ===
Source: hardening-wrapper
Section: devel
Priority: optional
Build-Depends: debhelper (>= 9), perl-base (>= 5.10)
Maintainer: Package Hardening <hardening-discuss@lists.alioth.debian.org>
Uploaders: Kees Cook <kees@debian.org>, Moritz Muehlenhoff <jmm@debian.org>
Standards-Version: 3.9.5
Homepage: http://wiki.debian.org/Hardening
Vcs-Bzr: http://anonscm.debian.org/bzr/hardening/master
Vcs-Browser: http://anonscm.debian.org/loggerhead/hardening/master/files/head:/hardening-wrapper/

Package: hardening-wrapper
Architecture: any
Multi-Arch: foreign
Depends: gcc | g++, ${perl:Depends}, ${misc:Depends}
Description: Compiler wrapper to enable security hardening flags
 Replaces gcc, g++, and ld with wrapper scripts that set security hardening
 compilation flags, as an alternative to changing gcc specs. Enabled when
 DEB_BUILD_HARDENING=1 is set.

Package: hardening-includes
Architecture: all
Multi-Arch: foreign
Depends: ${perl:Depends}, ${misc:Depends}, make, binutils
Description: Makefile for enabling compiler flags for security hardening
 Makefile to be included in Debian rules files. CFLAGS and LDFLAGS
 can be extended to include the respective HARDENING_* variables which
 contain architecture-validated security hardening compiler options.
 .
 Also includes the "hardening-check" script to help evaluate the hardening
 status of already compiled binaries.

## hardening-wrapper 2.7ubuntu1

=== debian/changelog ===
hardening-wrapper (2.7ubuntu1) vivid; urgency=medium

  * Merge with Debian; remaining changes:
    - Stop installing links for GCC 4.2, 4.3, 4.5.
  * Install links for GCC 5.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 18 Mar 2015 13:09:18 +0100

hardening-wrapper (2.7) unstable; urgency=medium

  * hardening.make: drop mips restriction on building PIE.
  * hardened-cc: fix comment typo, thanks to Steven Honeyman.
  * hardened-cc: disable format-security when related arguments
    are already present, thanks to Steve Beattie (Closes: 767269).
  * tests/Makefile.common: include tests for new format-security
    disabling abilities.

 -- Kees Cook <kees@debian.org>  Fri, 14 Nov 2014 10:27:04 -0800

## hardening-wrapper 2.7ubuntu2

=== tests/Makefile ===
#!/usr/bin/make -f

BUILD_TREE:=../build-tree

check: $(BUILD_TREE)/cc-test
	$(MAKE) -f Makefile.wrapper $@
	$(MAKE) -f Makefile.includes $@

clean:
	rm -f $(BUILD_TREE)/cc-test
	$(MAKE) -f Makefile.wrapper $@
	$(MAKE) -f Makefile.includes $@

$(BUILD_TREE)/cc-test:
	# Check the stack protector and PIE options directly, just to have
	# a historical record in the build logs.
	$(CC) -Wall -fstack-protector hello.c -o $(BUILD_TREE)/cc-test || true
	$(BUILD_TREE)/cc-test || true
	$(CC) -Wall -fstack-protector-strong hello.c -o $(BUILD_TREE)/cc-test || true
	$(BUILD_TREE)/cc-test || true
	$(CC) -Wall -fPIE -pie hello.c -o $(BUILD_TREE)/cc-test || true
	$(BUILD_TREE)/cc-test || true
	$(BUILD_TREE)/cc-test || true

.PHONY: check clean

=== debian/changelog ===
hardening-wrapper (2.7ubuntu2) xenial; urgency=high

  * Use -no-pie to disable PIE, when not otherwise enabled.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 05 Jan 2016 16:49:36 +0000

=== debian/rules ===
#!/usr/bin/make -f

# When building test binaries, disable the dpkg-buildflags hardening so
# that only hardening-wrapper's flags will be used for testing.
export DEB_BUILD_MAINT_OPTIONS=hardening=-all

%:
	dh $@

## hardening-wrapper 2.8+nmu3ubuntu1

=== debian/changelog ===
hardening-wrapper (2.8+nmu3ubuntu1) yakkety; urgency=medium

  * Divert the triplet prefixed linker binaries.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 01 Sep 2016 18:06:12 +0200

hardening-wrapper (2.8+nmu2ubuntu1) yakkety; urgency=medium

  * Merge with Debian; remaining changes:
    - Stop installing links for GCC 4.2, 4.3, 4.4, 4.5, 4.6
    - Use -no-pie to disable PIE, when not otherwise enabled.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 12 Aug 2016 07:48:31 +0100

hardening-wrapper (2.8+nmu2) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix setting ld symlink on x86 based architectures (Sven Joachim).
    Closes: #807949.

 -- Matthias Klose <doko@debian.org>  Mon, 14 Dec 2015 18:43:24 +0100

hardening-wrapper (2.8+nmu1) unstable; urgency=medium

  * Non-maintainer upload.
  * Upload as 2.8+nmu1 (binutils already has a conflict against << 2.8, the
    assumption that 2.8 would be uploaded in time didn't go well).
  * Install diversions for GCC 5 and GCC 6. Closes: #801597.
  * Divert the host_alias prefixed ld binaries instead of the unprefixed
    binaries. Closes: #802579.
  * Build-depend on binutils (>= 2.25.90).

 -- Matthias Klose <doko@debian.org>  Sun, 13 Dec 2015 21:48:47 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,8 @@
 Section: devel
 Priority: optional
 Build-Depends: debhelper (>= 9), perl-base (>= 5.10)
-Maintainer: Package Hardening <hardening-discuss@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Package Hardening <hardening-discuss@lists.alioth.debian.org>
 Uploaders: Kees Cook <kees@debian.org>, Moritz Muehlenhoff <jmm@debian.org>
 Standards-Version: 3.9.5
 Homepage: http://wiki.debian.org/Hardening
@@ -12,7 +13,7 @@
 Package: hardening-wrapper
 Architecture: any
 Multi-Arch: foreign
-Depends: gcc | g++, ${perl:Depends}, ${misc:Depends}
+Depends: gcc | g++, binutils (>= 2.25.90), ${perl:Depends}, ${misc:Depends}
 Description: Compiler wrapper to enable security hardening flags
  Replaces gcc, g++, and ld with wrapper scripts that set security hardening
  compilation flags, as an alternative to changing gcc specs. Enabled when

=== debian/rules ===
--- 
+++ 
@@ -4,5 +4,21 @@
 # that only hardening-wrapper's flags will be used for testing.
 export DEB_BUILD_MAINT_OPTIONS=hardening=-all
 
+export DHGT := $(subst i586,i686,$(shell dpkg-architecture -qDEB_HOST_GNU_TYPE))
+
 %:
 	dh $@
+
+override_dh_install:
+	env
+	for f in debian/*.in; do \
+	  sed 's/@DHGT@/$(DHGT)/g' $$f > $${f%*.in}; \
+	done
+	dh_install
+
+override_dh_clean:
+	for f in debian/*.in; do \
+	  rm -f $${f%*.in}; \
+	done
+	dh_clean
+
